PontosCulturais/ViewModels/AvisoViewModel.cs
using PontosCulturais.Singletons;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace PontosCulturais.ViewModels
{
    public class AvisoViewModel
    {
        public bool Erro { get; set; }
        public string Classe { get; set; }
        public string Mensagem { get; set; }
        public Erros CódigoErro { get; set; }
    }
}

PontosCulturais/Controllers/AdminController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using PontosCulturais.Geradores.Interfaces;
using PontosCulturais.Repositórios.Interface;
using PontosCulturais.Serviços.Interfaces;
using PontosCulturais.Singletons;
using PontosCulturais.ViewModels;

namespace PontosCulturais.Controllers
{
    public class AdminController : Controller
    {
        private readonly ISegurançaServiço _segurançaServiço;
        private readonly ILoginServiço _loginServiço;
        private readonly IAdminRepositório _adminRepositório;
        private readonly IAvisoViewModelGerador _avisoViewModelGerador;

        public AdminController(ISegurançaServiço segurançaServiço, ILoginServiço loginServiço, IAdminRepositório adminRepositório, IAvisoViewModelGerador avisoViewModelGerador)
        {
            _segurançaServiço = segurançaServiço;
            _loginServiço = loginServiço;
            _adminRepositório = adminRepositório;
            _avisoViewModelGerador = avisoViewModelGerador;
        }

        public IActionResult Index()
        {
            return View(new AdminViewModel());
        }

        public async Task<IActionResult> Logar(AdminViewModel viewModel)
        {
            if(!ModelState.IsValid) return View(nameof(Index), viewModel);

            var admin = _adminRepositório.ChecarLogin(viewModel);
            if(admin == null)
            {
                var novoViewModel = new AdminViewModel { Aviso = _avisoViewModelGerador.GerarMensagemErro("Usuário não encontrado", Erros.UsuárioNãoEncontrado) };
                return View(nameof(Index), novoViewModel);
            }

            await _loginServiço.LogarAdministradorAsync(HttpContext, admin);

            return RedirectToAction(nameof(Painel));
        }

        [Authorize(Roles = ConstantesAutenticaçãoSingleton.Administrador)]
        public IActionResult Painel()
        {
            return View();
        }

        [Authorize(Roles = ConstantesAutenticaçãoSingleton.Administrador)]
        public async Task<IActionResult> Sair()
        {
            await _loginServiço.LogoutAsync(HttpContext);
            return RedirectToAction(nameof(Index));
        }
    }

}

PontosCulturais/Controllers/PessoaFisicaController.cs
using System;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using PontosCulturais.Contexto;
using PontosCulturais.Controllers.Base;
using PontosCulturais.Exceptions.Base;
using PontosCulturais.Geradores.Interfaces;
using PontosCulturais.Models;
using PontosCulturais.Models.CadastroPessoaFísica;
using PontosCulturais.Repositórios.Interface;
using PontosCulturais.Serviços.Interfaces;
using PontosCulturais.Singletons;
using PontosCulturais.Singletons.Interfaces;
using PontosCulturais.ViewModels;

namespace PontosCulturais.Controllers
{
    public class PessoaFisicaController : EFControllerBase
    {
        //Repositórios
        private readonly IOpçõesCadastroPessoaFísicaRepositório _repositórioOpçõesCadastro;
        private readonly ICadastroPessoaFísicaRepositório _repositórioCadastroPessoaFísica;
        private readonly ISegmentosCulturaisRepositório _repositórioSegmentosCulturais;
        private readonly IResidentesRepositório _repositórioResidentes;
        private readonly IDocumentosPessoaFísicaRepositório _repositórioDocumentos;

        //Serviços
        private readonly ISegurançaServiço _criptografiaServiço;
        private readonly IUploadServiço _uploadServiço;
        private readonly IEmailServiço _emailServiço;

        //Validar
        private readonly IValidarModeloServiço<CadastroPessoaFísicaModelo> _validarPessoaFísica;
        private readonly IValidarModeloServiço<ResidenteModelo> _validarResidente;
        private readonly IValidarModeloServiço<DocumentosPessoaFísicaViewModel> _validarDocumentosViewModel;

        //Geradores
        private readonly IViewModelControllersGerador<CadastroPessoaFísicaViewModel> _geradorCadastroViewModel;
        private readonly IAvisoViewModelGerador _geradorAvisos;
        private readonly IResidentesViewModelGerador _geradorResidentesViewModel;
        private readonly IMostrarDadosViewModelGerador _geradorMostrarDadosViewModel;
        private readonly IViewModelControllersGerador<DocumentosPessoaFísicaViewModel> _geradorDocumentosViewModel;

        public PessoaFisicaController(AppContexto contexto, IViewModelControllersGerador<CadastroPessoaFísicaViewModel> geradorCadastroViewModel, IOpçõesCadastroPessoaFísicaRepositório repositórioOpçõesCadastro, 
            IValidarModeloServiço<CadastroPessoaFísicaModelo> validarPessoaFísica, IAvisoViewModelGerador geradorAvisos, ICadastroPessoaFísicaRepositório repositórioCadastroPessoaFísica,
            ISegmentosCulturaisRepositório repositórioSegmentosCulturais, ISegurançaServiço criptografiaServiço, IResidentesRepositório repositórioRedidentes, 
            IResidentesViewModelGerador geradorResidentesViewModel, IValidarModeloServiço<ResidenteModelo> validarResidente, IMostrarDadosViewModelGerador geradorMostrarDadosViewModel,
            IViewModelControllersGerador<DocumentosPessoaFísicaViewModel> geradorDocumentosViewModel, IUploadServiço uploadServiço, IValidarModeloServiço<DocumentosPessoaFísicaViewModel> validarDocumentosViewModel,
            IDocumentosPessoaFísicaRepositório repositórioDocumentos, IEmailServiço emailServiço) 
            : base(contexto)
        {
            _geradorCadastroViewModel = geradorCadastroViewModel;
            _repositórioOpçõesCadastro = repositórioOpçõesCadastro;
            _validarPessoaFísica = validarPessoaFísica;
            _geradorAvisos = geradorAvisos;
            _repositórioCadastroPessoaFísica = repositórioCadastroPessoaFísica;
            _repositórioSegmentosCulturais = repositórioSegmentosCulturais;
            _criptografiaServiço = criptografiaServiço;
            _repositórioResidentes = repositórioRedidentes;
            _geradorResidentesViewModel = geradorResidentesViewModel;
            _validarResidente = validarResidente;
            _geradorMostrarDadosViewModel = geradorMostrarDadosViewModel;
            _geradorDocumentosViewModel = geradorDocumentosViewModel;
            _uploadServiço = uploadServiço;
            _validarDocumentosViewModel = validarDocumentosViewModel;
            _repositórioDocumentos = repositórioDocumentos;
            _emailServiço = emailServiço;

        }

        public IActionResult Cadastrar()
        {

            var viewModel = _geradorCadastroViewModel.GerarViewModelInicial();
            CarregarListasModelo(viewModel);
            return View(viewModel);
        }


        [HttpPost] [ValidateAntiForgeryToken]
        public IActionResult Finalizar(CadastroPessoaFísicaViewModel modelo)
        {
            var resultado = _validarPessoaFísica.Validar(modelo.Cadastro);
            if (resultado.Erro)
            {
                CarregarListasModelo(modelo);
                modelo.Aviso = resultado;
                return View(nameof(Cadastrar), modelo);
            }

            if(!_repositórioCadastroPessoaFísica.VerificarCPFÚnico(modelo.Cadastro.CPF))
            {
                CarregarListasModelo(modelo);
                modelo.Aviso = _geradorAvisos.GerarMensagemErro("CPF já usado", Erros.CPFRepetidoCadastroCadastro);
                return View(nameof(Cadastrar), modelo);
            }

            if(!_repositórioCadastroPessoaFísica.VerificarEmailÚnico(modelo.Cadastro.Email))
            {
                CarregarListasModelo(modelo);
                modelo.Aviso = _geradorAvisos.GerarMensagemErro("Email já usado", Erros.EmailRepetido);
                return View(nameof(Cadastrar), modelo);
            }

            if(!_repositórioCadastroPessoaFísica.VerificarRGÚnico(modelo.Cadastro.RG))
            {
                CarregarListasModelo(modelo);
                modelo.Aviso = _geradorAvisos.GerarMensagemErro("RG já usado", Erros.RGRepetido);
                return View(nameof(Cadastrar), modelo);
            }

            if(!_repositórioResidentes.VerificarCPFCertidãoNãoCadastrado(modelo.Cadastro.CPF))
            {
                CarregarListasModelo(modelo);
                modelo.Aviso = _geradorAvisos.GerarMensagemErro("CPF já usada como residente em outro cadastro", Erros.CPFRepetidoCadastroResidente);
                return View(nameof(Cadastrar), modelo);
            }

            modelo.Cadastro.Senha = _criptografiaServiço.Criptografar(modelo.Cadastro.Senha);
            _repositórioCadastroPessoaFísica.Inserir(modelo.Cadastro);
            var segmentos = _repositórioSegmentosCulturais.RetornarSegmentos(modelo.Cadastro.SegmentosCulturaisId);
            var entradasRelacionamento = segmentos.Select(sc => new SegmentoCulturalPessoaFísicaModelo { PessoaFísica = modelo.Cadastro, SegmentoCultural = sc });
            _repositórioSegmentosCulturais.InserirRelacionamentos(entradasRelacionamento);
            SalvarAlterações();

            var token = _criptografiaServiço.GerarToken(modelo.Cadastro.Id, PropósitoToken.ConfirmarEmail);
            _emailServiço.EnviarEmailConfirmação(token, modelo.Cadastro.Email);

            return View("Sucesso");
        }

        [Authorize(Roles = ConstantesAutenticaçãoSingleton.CandidatoAoAuxílio)]
        public IActionResult Residentes()
        {
            var idUsuário = RetornarID();
            var residentes = _repositórioResidentes.RetornarResidentes(idUsuário);
            var viewModel = _geradorResidentesViewModel.GerarViewModelInicial(residentes);

            return View(viewModel);
        }



        [HttpPost] [ValidateAntiForgeryToken] [Authorize(Roles = ConstantesAutenticaçãoSingleton.CandidatoAoAuxílio)]
        public IActionResult CadastrarResidente(ResidentesViewModel viewModel)
        {
            var resultado = _validarResidente.Validar(viewModel.Residente);
            var idUsuário = RetornarID();

            if (resultado.Erro)
            {
                var residentes = _repositórioResidentes.RetornarResidentes(idUsuário);
                var novoViewModel = _geradorResidentesViewModel.GerarComAviso(residentes, resultado);
                return View(nameof(Residentes), novoViewModel);
            }

            if(!_repositórioCadastroPessoaFísica.VerificarCPFÚnico(viewModel.Residente.CPFOuCertidão))
            {
                var residentes = _repositórioResidentes.RetornarResidentes(idUsuário);
                var aviso = _geradorAvisos.GerarMensagemErro("CPF já cadastrado como usuário pessoa física", Erros.CPFRepetidoResidenteCadastro);
                var novoViewModel = _geradorResidentesViewModel.GerarComAviso(residentes, aviso);

                return View(nameof(Residentes), novoViewModel);
            }

            if(!_repositórioResidentes.VerificarCPFCertidãoNãoCadastrado(viewModel.Residente.CPFOuCertidão))
            {
                var residentes = _repositórioResidentes.RetornarResidentes(idUsuário);
                var aviso = _geradorAvisos.GerarMensagemErro("CPF/Registro de Nascimento já cadastrado por você ou outra pessoa", Erros.CPFRepetidoResidenteResidente);
                var novoViewModel = _geradorResidentesViewModel.GerarComAviso(residentes, aviso);

                return View(nameof(Residentes), novoViewModel);
            }

            viewModel.Residente.CadastroPessoaFísicaModeloId = idUsuário;
            _repositórioResidentes.Inserir(viewModel.Residente);
            SalvarAlterações();

            return RedirectToAction(nameof(Residentes));
        }

        [Authorize(Roles = ConstantesAutenticaçãoSingleton.CandidatoAoAuxílio)]
        public IActionResult Visualizar()
        {
            var id = RetornarID();
            var usuário = _repositórioCadastroPessoaFísica.RetornarPorIdComJoins(id);
            var segmentos = _repositórioSegmentosCulturais.RetornarSegmentosPessoaFísica(id);
            var viewModel = _geradorMostrarDadosViewModel.GerarViewModelInicial(usuário, segmentos);

            return View(viewModel);
        }

        [Authorize(Roles = ConstantesAutenticaçãoSingleton.CandidatoAoAuxílio)]

PontosCulturais/Views/Shared/_Aviso.cshtml
@model PontosCulturais.ViewModels.AvisoViewModel

@if(Model != null && !string.IsNullOrEmpty(Model.Mensagem))
{
    <div class="alert @Model.Classe" role="alert">
        @Model.Mensagem
    </div>
}

PontosCulturais/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>AldirBlanc</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    <link rel="stylesheet" href="~/css/custom.css" />

    @RenderSection("Css", required: false)
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Lei Emergencial Aldir Blanc</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="PessoaFisica" asp-action="Cadastrar">Cadastrar Pessoa Física</a>
                        </li>
                        <li class="nav-item">
                            @if (User.Identity.IsAuthenticated)
                            {
                                if (User.IsInRole(ConstantesAutenticaçãoSingleton.Administrador))
                                {
                                    <a class="nav-link text-dark" asp-controller="Admin" asp-action="Painel">Painel Administrativo</a>
                                }
                                else
                                {
                                    <a class="nav-link text-dark" asp-controller="Painel" asp-action="Mostrar">Painel do Usuário</a>
                                }
                            }
                            else
                            {
                                <a class="nav-link text-dark" asp-area="" asp-controller="Painel" asp-action="Entrar">Entrar</a>
                            }
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted bg-light">
        <div class="container">
            &copy; 2020 - <a href="https://portonacional.to.gov.br/">Prefeitura de Porto Nacional</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>